# Automotive boot check

auto-boot-check is a small C program designed to validate that various
aspects of the system configuration is correcly setup during the boot
process. It is started by systemd at the end of bootup, and does
checks as defined by drop-in configuration files. If any of the checks
fail, the service will fail.

auto-boot-check be integrated with e.g. greenboot to trigger special
actions (like reboot) on failure.

## Available checks

auto-boot-check reads files matching `/etc/boot-check.d/*.conf` and
`/usr/lib/boot-check.d/*.conf` that defines checks. These files
contain one check per line starting with a check type and followed by
space separated arguments.


The following check types are supported:

* `ip <address> <ip prefix length>` - Check that there is an active physical network interface with this ipv4 address and netmask.
* `default_gw <addres>` - Check that the default network route is the specified ipv4 address.
* `nameserver <address>` - Check that the specified address is configured as the nameserver in /etc/resolv.conf
* `container_checksum <container name> <digest>` - Compare the checksum of OCI config for the podman container with the given checksum. The expected checksum can be computed using `auto-boot-check-tool container-checksum <container-name>`.

An example file may look like this:
```
ip 192.168.68.121 24
default_gw 192.168.68.1
nameserver 127.0.0.53
```
